<template>

    <div>
        <q-btn fab icon="share" @click="dialog = true; $emit('open')" class="fixed-bottom-right q-ma-lg shadow-12" style="z-index:100; " color="accent"/>
        <q-dialog v-model="dialog">
            <div class="bg-base  q-pa-lg full-width" style="max-width: 800px;">
                <slot name="before"></slot>
                <q-input readonly filled v-model="link" bottom-slots label="Share Link">

                    <template v-slot:append>
                        <q-icon name="content_copy" @click="CopyToClipboard" class="cursor-pointer"/>
                    </template>

                    <template v-slot:hint>
                        Copy the link to share with this map at this time with someone
                    </template>
                </q-input>
                <slot name="after"></slot>
            </div>
        </q-dialog>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {copyToClipboard} from "quasar";
import {SuccessMessage, WarnMessage} from "src/classLibrary/Utility";

@Component
export default class ShareButton extends Vue {
    @Prop() link!: string;
    dialog = false;


    CopyToClipboard() {
        copyToClipboard(this.link)
            .then(() => {
                this.$q.notify(SuccessMessage('Copied'));
            })
            .catch(() => {
                this.$q.notify(WarnMessage("Failed to copy"));
            });
    }

}
</script>

<style lang='scss' scoped>

</style>
